正在加载中……
最新消息:欢迎大家访问,导航分类不完善,如果找不到自己想要的文章,可以通过【关键词】来进行搜索,^_^!

Linux下SVN(Subversion)自动启动脚本

Linux专题 REKFAN.COM 26281浏览 0评论

更多


给大家分享下三种自动脚本,由易到难!

脚本一 脚本一:

下面的shell脚本启动,是根据多项目使用的
svnserve -d --listen-port 3690 -r /svnroot/rekfan.com/
svnserve -d --listen-port 3691 -r /svnroot/rekfan.cn/

svn默认启动端口是3690,这里有两个svn库,所以当出现这样的情况时,上面的服务脚本只会启动一个svn库.所以就需要使用shell脚本来实现启动两个svn库.

vi /root/svn.sh

svn.sh脚本内容:

#!/bin/bash
svnserve -d --listen-port 3690 -r /svnroot/rekfan.com/
svnserve -d --listen-port 3691 -r /svnroot/rekfan.cn/

然后添加可执行权限

chmod 700 /root/svn.sh或chmod ug+x /root/svn.sh

添加到自动运行

vi /etc/rc.local

在最后添加一行内容

/root/svn.sh

然后重启服务器,使用ps aux|grep svn来查看svn是否启动

脚本二:

svn服务自启动脚本

把脚本放在/etc/init.d/下

vi /etc/rc.d/init.d/svn

svn脚本内容:
#!/bin/bash
# chkconfig: - 85 15
# description: svn server
SVN_HOME=/svnroot/rekfan.com
if [ ! -f "/usr/bin/svnserve" ]
then
echo "svnserver startup: cannot start"
exit
fi
case "$1" in
start)
echo "Starting svnserve…"
/usr/local/svn/bin/svnserve -d --listen-port 3690 -r $SVN_HOME
echo "Finished!"
;;
stop)
echo "Stoping svnserve…"
killall svnserve
echo "Finished!"
;;
restart)
$0 stop
$0 start

;;
*)
echo "Usage: svn { start | stop | restart } "
exit 1
esac

这里请注意,不要删除# chkconfig: - 85 15和# description: svn server,不然无法使用chkconfig加入服务,会提示service svn does not support chkconfig.

然后执行

chmod 755 /etc/init.d/svn

chkconfig --add svn

chkconfig svn on

最后查看下chkconfig --list|grep svn

脚本三:

#! /bin/sh -e
### BEGIN INIT INFO
# Provides:          svnserve
# Required-Start:    $local_fs $syslog $remote_fs
# Required-Stop:     $local_fs $syslog $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Start/Stop svnserve
### END INIT INFO
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="svnserve"
NAME=svnserve
PIDFILE=/var/run/$NAME.pid
DAEMON=/usr/bin/$NAME
#why add --pid-file parameter here? svnserve writes correct PID into PIDFILE.
#start-stop-daemon writes the PID before the process running. It may cause the PID nubmer dismatch.
#So, Please DO NOT rely on the --make-pidfile option
DAEMON_ARGS="-d -r /opt/svnproject --pid-file=$PIDFILE"
SCRIPTNAME=/etc/init.d/$NAME
[ -x "$DAEMON" ] || exit 0
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
. /lib/lsb/init-functions
do_start()
{
start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null /
|| return 1
start-stop-daemon --start --quiet --background --exec $DAEMON -- /
$DAEMON_ARGS /
|| return 2
}
#For those prcesses with chilren processes. Please stop with --exec, plus command name.
#--pid-file can only kill parent process. All the children processes will be transferred to 1.
do_stop()
{
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --exec "$DAEMON"
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec "$DAEMON"
[ "$?" = 2 ] && return 2
rm -f $PIDFILE
return "$RETVAL"
}
case "$1" in
start)
log_daemon_msg "Starting $DESC" "$NAME"
if [ -s $PIDFILE ] && kill -0 $(cat $PIDFILE) >/dev/null 2>&1; then
log_daemon_msg "apparently already running"
log_end_msg 0
exit 0
fi
do_start
case "$?" in
0|1) log_end_msg 0 ;;
2)  log_end_msg 1 ;;
esac
;;
stop)
log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) log_end_msg 0 ;;
2)  log_end_msg 1 ;;
esac
;;
restart|force-reload)
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
exit 3
;;
esac
exit 0

以上脚本转载自网络其他资源
如果还有更好的方法请发我E-Mail:webmaster
&rekfan.com [&换成@]

转载请注明:|REKFAN|系统运维| » Linux下SVN(Subversion)自动启动脚本

表情

Hi,您需要填写昵称和邮箱!

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址